(
	global MNR_Rollout
	try (destroydialog MNR_Rollout)catch()
	
	local prefix = undefined 
	local suffix = undefined
	local bad = undefined
	local valFirst = undefined
	local valLast = undefined
	local indexLast = undefined
	
	rollout MNR_Rollout "Mass Material Name Editor" 
	(
	button 'btn1' "Edit" pos:[10,345] width: 210 height: 40 align:#center tooltip: "Note: The script affects only the applied materials in the scene. Removal of symbols is done prior to addition."
		
	groupBox 'grp1' "Add symbols:" pos: [20,20] width: 190 height: 100 align: #left
		
	edittext 'edt1' "Prefix" pos: [30,45] text: "" width: 170 height: 20 align:#right labelontop: false
	edittext 'edt2' "Suffix" pos: [30,80] text: "" width: 170 height: 20 align:#right labelontop: false
	
	groupBox 'grp2' "Remove symbols:" pos: [20, 125] width: 190 height: 135 align: #left
		
	spinner 'removef' "First:" pos:[30,150] width:60 height:24 type: #integer align:#left range:[0,100,0] scale: 1
	spinner 'removel' "Last:" pos:[30,175] width:60 height:24 type: #integer align:#left range:[0,100,0] scale: 1
	spinner 'removefrom' "From startnig index:" pos:[30,200] width:80 height:24 type: #integer align:#left range:[0,100,0] scale: 1
	spinner 'removeto' "Length:" pos:[30,225] width:60 height:24 type: #integer align:#left range:[0,100,0] scale: 1
	
	edittext 'edt3' "Affect material names containing:" pos: [20,270] text: "" width: 190 height: 20 align:#right labelontop: true
	checkbox 'afselected' "Affect only selected objects" pos: [20, 320] checked: false 
	
		
	on btn1 pressed do (
		prefix = edt1.text
		suffix = edt2.text
		bad = "*" + edt3.text + "*"
		valFirst = removef.value
		valLast = removel.value
		valFrom = removefrom.value
		valLength = removeto.value
		
		if afselected.checked == false then (
		
		for m in scenematerials where matchPattern m.name pattern: bad == true do (
		
		indexLast = m.name.count
			
		if valFirst != 0 do (
			if indexLast > valFirst do(
			newName = replace m.name 1 valFirst ""
			m.name = newName
			)
		)
		if valLast !=0 do (
			if indexLast > valLast do(
			newName = replace m.name (indexLast - valLast + 1) valLast ""
			m.name = newName
			)
		)
		if valFrom !=0 and valLength !=0 do (
			if indexLast >= valLength + valFrom then (
			newName = replace m.name valFrom valLength ""
			m.name = newName
			)
			else print "Error: Symbol sum higher than symbols in some material names."
		)
		
		m.name = prefix + m.name + suffix
		
			)
		)
		else (
				for m in $ where matchPattern m.material.name pattern: bad == true do (
		
		indexLast = m.material.name.count
			
		if valFirst != 0 do (
			if indexLast > valFirst do(
			newName = replace m.name 1 valFirst ""
			m.name = newName
			)
		)
		if valLast !=0 do (
			if indexLast > valLast do(
			newName = replace m.material.name (indexLast - valLast + 1) valLast ""
			m.material.name = newName
			)
		)
		if valFrom !=0 and valLength !=0 do (
			if indexLast >= valLength + valFrom then (
			newName = replace m.material valFrom valLength ""
			m.material.name = newName
			)
			else print "Error: Symbol sum higher than symbols in some material names."
		)
		
		m.material.name = prefix + m.material.name + suffix
		
			)
			)
		)
	)
createDialog MNR_Rollout 230 395
)
